/*****************************************************************************
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************
 * Software that is described herein is for illustrative purposes only
 * which provides customers with programming information regarding the
 * products. This software is supplied "AS IS" without any warranties.
 * Embedded Artists AB assumes no responsibility or liability for the
 * use of the software, conveys no license or title under any patent,
 * copyright, or mask work right to the product. Embedded Artists AB
 * reserves the right to make changes in the software without
 * notification. Embedded Artists AB also make no representation or
 * warranty that such application will be suitable for the specified
 * use without further testing or modification.
 *****************************************************************************/

#include "board.h"

/*****************************************************************************
 * Private types/enumerations/variables
 ****************************************************************************/

/*****************************************************************************
 * Public types/enumerations/variables
 ****************************************************************************/

/*****************************************************************************
 * Private functions
 ****************************************************************************/

static void PrintGreeting(void)
{
	DEBUGOUT("\r\n*****************************************************\r\n");
	DEBUGOUT("*                                                   *\r\n");
	DEBUGOUT("* Demos memory mapped LEDs for LPC4357 OEM Board... *\r\n");
	DEBUGOUT("* (C) Embedded Artists 2001-2013                    *\r\n");
	DEBUGOUT("*                                                   *\r\n");
	DEBUGOUT("*                             " __DATE__ ", " __TIME__ " *\r\n");
	DEBUGOUT("*****************************************************\r\n");
}


/*****************************************************************************
 * Public functions
 ****************************************************************************/

/**
 * @brief	Main entry point
 * @return	Nothing
 */
int main(void)
{
	uint16_t* memreg = (uint16_t*) MEMREG_BASE;

	SystemCoreClockUpdate();
	Board_Init();

	/* Print the Demo Information */
	PrintGreeting();

	/* The Memory Mapping is already done in board_sysinit.c for the
	 * LEDs so there is nothing extra to do here
	 */

	/* Write a bit mask which enables/disables
	   the memory mapped LEDs on the OEM Base Board */
	*memreg = 0x55AA;

	while (1) {
		*memreg = 0xAA55;
		Board_DelayMs(100);
		*memreg = 0x55AA;
		Board_DelayMs(100);
	}
}
