/*
* Copyright(C) NXP Semiconductors, 2011
* All rights reserved.
*
* Software that is described herein is for illustrative purposes only
* which provides customers with programming information regarding the
* LPC products.  This software is supplied "AS IS" without any warranties of
* any kind, and NXP Semiconductors and its licensor disclaim any and 
* all warranties, express or implied, including all implied warranties of 
* merchantability, fitness for a particular purpose and non-infringement of 
* intellectual property rights.  NXP Semiconductors assumes no responsibility
* or liability for the use of the software, conveys no license or rights under any
* patent, copyright, mask work right, or any other intellectual property rights in 
* or to any products. NXP Semiconductors reserves the right to make changes
* in the software without notification. NXP Semiconductors also makes no 
* representation or warranty that such application will be suitable for the
* specified use without further testing or modification.
* 
* Permission to use, copy, modify, and distribute this software and its 
* documentation is hereby granted, under NXP Semiconductors' and its 
* licensor's relevant copyrights in the software, without fee, provided that it 
* is used in conjunction with NXP Semiconductors microcontrollers.  This 
* copyright, permission, and disclaimer notice must appear in all copies of 
* this code.
*/



#ifndef __BSP_EAOEMBASE_REVA_43XX_H__
#define __BSP_EAOEMBASE_REVA_43XX_H__

#include "lpc43xx_uart.h"
#include "lpc43xx_dac.h"
#include "lpc43xx_scu.h"
#include "lpc43xx_cgu.h"
#include "lpc43xx_gpio.h"
#include "lpc43xx_timer.h"
#include "lpc43xx_i2c.h"
#include "lpc43xx_gpdma.h"
#include "lpc43xx_i2s.h"
#include "lpc43xx_emc.h"

//#define LPC_TIMER0			LPC_TIM0

#define DEBUG_UART_PORT	((LPC_USARTn_Type*)LPC_USART0)
// #define UART_FUNCNUM		1
// #define UART_PORTNUM		0
// #define UART_TX_PINNUM		2
// #define UART_RX_PINNUM		3

// #define BUTTONS_BUTTON1_GPIO_PORT_NUM			2
// #define BUTTONS_BUTTON1_GPIO_BIT_NUM			7    //  1788:P2.10 -> connector 35 -> 4357:P2.7

// #define JOYSTICK_UP_GPIO_PORT_NUM				  0x9 
// #define JOYSTICK_UP_GPIO_BIT_NUM				  0x0   //  1788:P2.26 -> connector 123 -> 4357:P9.0
// #define JOYSTICK_DOWN_GPIO_PORT_NUM				0xa 
// #define JOYSTICK_DOWN_GPIO_BIT_NUM				0x2   //  1788:P2.23 -> connector 121 -> 4357:PA.2
// #define JOYSTICK_LEFT_GPIO_PORT_NUM				0xa 
// #define JOYSTICK_LEFT_GPIO_BIT_NUM				0x3   //  1788:P2.25 -> connector 122 -> 4357:PA.3
// #define JOYSTICK_RIGHT_GPIO_PORT_NUM			0x9 
// #define JOYSTICK_RIGHT_GPIO_BIT_NUM				0x1   //  1788:P2.27 -> connector 124 -> 4357:P9.1
// #define JOYSTICK_PRESS_GPIO_PORT_NUM			0xa 
// #define JOYSTICK_PRESS_GPIO_BIT_NUM				0x1   //  1788:P2.22 -> connector 120 -> 4357:PA.1

#ifdef __CODE_RED
	#include <cr_section_macros.h>
#elif defined(__CC_ARM) // FIXME temporarily fix for Keil (work only for lpc17xx)
	#define __DATA(x)	__attribute__((section("usbram")))
#endif
#define USBRAM_SECTION RAM2
#endif
