/******************************************************************************
 *
 * Copyright:
 *    (C) 2000 - 2005 Embedded Artists AB
 *
 *****************************************************************************/

#ifndef _ETHAPI_H_
#define _ETHAPI_H_



#define INBUF_LEN 1500

/*****************************************************************************
 *
 * Description:
 *    Initialize the ethernet driver
 *
 * Params:
 *    [in] pEthAddr - the Ethernet (MAC) address. Must be 6 bytes long.
 *
 ****************************************************************************/
uint32_t ethIf_init(uint8_t* pEthAddr);

/*****************************************************************************
 *
 * Description:
 *    Send an ethernet packet. 
 *
 * Params:
 *    [in] pData - the data to send
 *    [in] len   - length of the data to send
 *
 ****************************************************************************/
void ethIf_send(uint8_t* pData, 
                uint16_t len);

/*****************************************************************************
 *
 * Description:
 *    Poll the driver for incoming packets. 
 *
 * Params:
 *    [in/out] pBuf - allocated buffer to hold the incoming packet
 *    [in]     len  - length of the buffer
 *
 * Returns:
 *    Length of the received packet.
 *
 ****************************************************************************/
uint16_t ethIf_poll(uint8_t* pBuf, 
                  uint16_t len);


void
ethInput(uint8_t* pBuf, 
         uint16_t len);

/*****************************************************************************
 *
 * Description:
 *    Reset ping counter
 *
 ****************************************************************************/
void pingReset(void);

/*****************************************************************************
 *
 * Description:
 *    Get number of received ping requests
 *
 ****************************************************************************/
uint32_t pingGetNumReceived(void);

#endif
