/******************************************************************************
 *
 * Copyright:
 *    (C) 2000 - 2005 Embedded Artists AB
 *
 *****************************************************************************/

#ifndef _MEAS_H_
#define _MEAS_H_

#include "lpc43xx_scu.h"

#define _INTERNAL_TOGGLE_MEAS_PIN(__port, __pin) (LPC_GPIO_PORT->NOT[(__port)] |= (1UL << (__pin)))
#define _INTERNAL_SET_MEAS_PIN(__port, __pin)    (LPC_GPIO_PORT->SET[(__port)] |= (1UL << (__pin)))
#define _INTERNAL_CLR_MEAS_PIN(__port, __pin)    (LPC_GPIO_PORT->CLR[(__port)] |= (1UL << (__pin)))

#define TOGGLE_MEAS_PIN_1()  _INTERNAL_TOGGLE_MEAS_PIN(6, 1)
#define SET_MEAS_PIN_1()     _INTERNAL_SET_MEAS_PIN(6, 1)
#define CLR_MEAS_PIN_1()     _INTERNAL_CLR_MEAS_PIN(6, 1)

#define TOGGLE_MEAS_PIN_2()  _INTERNAL_TOGGLE_MEAS_PIN(7, 22)
#define SET_MEAS_PIN_2()     _INTERNAL_SET_MEAS_PIN(7, 22)
#define CLR_MEAS_PIN_2()     _INTERNAL_CLR_MEAS_PIN(7, 22)

static meas_setup(void) {
  // LPC4357 OemBoard: PC_2,FUNC4 => GPIO6[1]  (GPIO72 on OemBaseBoard, J5-55)
  scu_pinmux(0xc, 2, MD_PDN, FUNC4);
  LPC_GPIO_PORT->DIR[6] |= (1UL << 1);  
  CLR_MEAS_PIN_1();

  // LPC4357 OemBoard: PF_8,FUNC4 => GPIO7[22]  (GPIO78 on OemBaseBoard, J5-58)
  scu_pinmux(0xf, 8, MD_PDN, FUNC4);
  LPC_GPIO_PORT->DIR[7] |= (1UL << 22);
  CLR_MEAS_PIN_2();
}

#endif
