/*****************************************************************************
 *
 *   Copyright(C) 2011, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************
 * Software that is described herein is for illustrative purposes only
 * which provides customers with programming information regarding the
 * products. This software is supplied "AS IS" without any warranties.
 * Embedded Artists AB assumes no responsibility or liability for the
 * use of the software, conveys no license or title under any patent,
 * copyright, or mask work right to the product. Embedded Artists AB
 * reserves the right to make changes in the software without
 * notification. Embedded Artists AB also make no representation or
 * warranty that such application will be suitable for the specified
 * use without further testing or modification.
 *****************************************************************************/

/******************************************************************************
 * Includes
 *****************************************************************************/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "lpc_types.h"
#include "lpc43xx_cgu.h"
// #include "lpc43xx_i2c.h"
#include "lpc43xx_rgu.h"
// #include "lpc43xx_ssp.h"
#include "lpc43xx_timer.h"
// #include "lpc43xx_uart.h"

// #include "sdram.h"
// #include "lcd_driver.h"
// #include "lpc_swim.h"
// #include "lpc_swim_font.h"
// #include "ea_lcd_board.h"
// #include "pca9532.h"
// #include "tsc2046_touch.h"
// #include "truly_display.h"
// #include "lcdb_eeprom.h"
#include "board.h"
#include "memreg.h"

/******************************************************************************
 * Typedefs and defines
 *****************************************************************************/

// #define I2C_PORT (LPC_I2C0)

// /* Buffer size for retrieving the display information */
// #define MAIN_BUF_SZ 100

/******************************************************************************
 * Local variables
 *****************************************************************************/

// /* Buffer for retrieving the display information */
// static char main_buf[MAIN_BUF_SZ];

/* Buffer for printing */
static char buff[512];

// static int touch_calibrated = 0;

/******************************************************************************
 * External Functions
 *****************************************************************************/

// void calibrateStart(SWIM_WINDOW_T *win);

/******************************************************************************
 * Local Functions
 *****************************************************************************/

static void PrintGreeting(void)
{
  console_sendString("\r\n****************************************************\r\n");
  console_sendString("*                                                  *\r\n");
  console_sendString("* Demos memory mapped LEDs for LPC4357 OEM Board...*\r\n");
  console_sendString("* (C) Embedded Artists 2001-2013                   *\r\n");
  console_sendString("*                                                  *\r\n");
  sprintf(buff, "*                            %s, %s *\r\n", __DATE__, __TIME__);
  console_sendString((uint8_t*)buff);
  console_sendString("****************************************************\r\n");
}


/******************************************************************************
 * Main method
 *****************************************************************************/



int main (void)
{
  int i;
  uint16_t* memreg = (uint16_t*)MEMREG_BASE;
	TIM_TIMERCFG_Type timerCfg;

  SystemInit();
  CGU_Init(BOARD_MAX_SPEED);

  RGU_SoftReset(RGU_SIG_EMC);
  RGU_SoftReset(RGU_SIG_GPIO);
  RGU_SoftReset(RGU_SIG_TIMER0);
  
  // initialize timer
  TIM_ConfigStructInit(TIM_TIMER_MODE, &timerCfg);
  TIM_Init(LPC_TIMER0, TIM_TIMER_MODE, &timerCfg);

  console_init();
  memreg_init();

  PrintGreeting();

  // write a bit mask which enables/disables 
  // LED1 to LED16 on the OEM Base Board
  *memreg = 0x55AA;

  while(1)
  {
    *memreg = 0xAA55;
    for(i = 0; i < 0x200000; i++);
    *memreg = 0x55AA;
    for(i = 0; i < 0x200000; i++);
  }
}


